	.model small,C
	.data
	extrn _no_snow:byte
	extrn _cursor_on:byte
start_address   DW      0
	.code
	public  scroll_,clear_screen_,put_screen_,get_screen_
	public  show_cursor_,hide_cursor_,set_cursor_address_
put_screen_:
	push    es
	push    si
	push    ax
	push    dx
	mov     si,0B800h
	mov     es,si
	mov     si,ax
	add     si,start_address
	mov     ah,dl
	cmp     _no_snow,0
	je      put_screen_fast
	mov     dx,03DAh
w1:     in      al,dx
	and     al,1
	jnz     w1
w2:     in      al,dx
	and     al,1
	jz      w2
put_screen_fast:
	mov     es:[si],ah
	pop     dx
	pop     ax
	pop     si
	pop     es
	ret

set_cursor_address_:
	cmp     _cursor_on,1
	jne     put_screen_end
	push    si
	push    ax
	push    dx
	mov     si,ax
	add     si,start_address
	shr     si,1
	mov     dx,03D4h
	mov     al,14
	out     dx,al
	inc     dx
	mov     ax,si
	mov     al,ah
	out     dx,al
	mov     dx,03D4h
	mov     al,15
	out     dx,al
	inc     dx
	mov     ax,si
	out     dx,al
	pop     dx
	pop     ax
	pop     si
put_screen_end:
	ret


show_cursor_:
	push    dx
	push    ax
	mov     dx,03D4h
	mov     al,10
	out     dx,al
	inc     dx
	mov     al,0
	out     dx,al
	mov     dx,03D4h
	mov     al,11
	out     dx,al
	inc     dx
	mov     al,15
	out     dx,al
	pop     ax
	pop     dx
	ret
	
hide_cursor_:
	push    dx
	push    ax
	mov     dx,03D4h
	mov     al,10
	out     dx,al
	inc     dx
	mov     al,15
	out     dx,al
	mov     dx,03D4h
	mov     al,11
	out     dx,al
	inc     dx
	mov     al,15
	out     dx,al
	pop     ax
	pop     dx
	ret
	
get_screen_:
	push    es
	push    si
	push    dx
	mov     si,ax
	add     si,start_address
	mov     ax,0B800h
	mov     es,ax
	mov     ah,0
	cmp     _no_snow,0
	je      get_screen_fast
	mov     dx,03DAh
w3:     in      al,dx
	and     al,1
	jnz     w3
w4:     in      al,dx
	and     al,1
	jz      w4
get_screen_fast:
	mov     al,es:[si]
	pop     dx
	pop     si
	pop     es
	ret

set_start_address:
	push    dx
	and     ax,3FFFh
	mov     start_address,ax
	mov     dx,03D4h
	mov     al,12
	out     dx,al
	inc     dx
	mov     ax,start_address
	shr     ax,1
	xchg    al,ah
	out     dx,al
	mov     dx,03D4h
	mov     al,13
	out     dx,al
	inc     dx
	mov     al,ah
	out     dx,al
	pop     dx
	ret

scroll_:
	push    es
	push    ax
	push    cx
	push    dx
	push    di
	cmp     _no_snow,0
	je      scroll2
	mov     dx,03D8h
	mov     al,021h
	out     dx,al
scroll2:
	mov     ax,0B800h
	mov     es,ax
	mov     di,start_address
	add     di,25*80*2
	mov     ax,0F20h
	mov     cx,16
	rep     stosw
	and     di,3FFFh
	mov     cx,16
	rep     stosw
	and     di,3FFFh
	mov     cx,16
	rep     stosw
	and     di,3FFFh
	mov     cx,16
	rep     stosw
	and     di,3FFFh
	mov     cx,16
	rep     stosw
	cmp     _no_snow,0
	je      scroll_end
	mov     dx,03D8h
	mov     al,029h
	out     dx,al
scroll_end:
	mov     ax,start_address
	add     ax,80*2
	call    set_start_address
	pop     di
	pop     dx
	pop     cx
	pop     ax
	pop     es
	ret

clear_screen_:
	push    es
	push    di
	push    ax
	push    cx
	mov     ax,0
	call    set_start_address
	mov     ax,0
	call    set_cursor_address_
	mov     di,0
	mov     ax,0B800h
	mov     es,ax
	mov     ax,0F20h
	mov     cx,25*80
	cld
	rep     stosw
	pop     cx
	pop     ax
	pop     di
	pop     es
	ret
	
	
	end
