	public set_comm_params_, put_rs232_
	public install_rs232_, uninstall_rs232_
	.model small,C

	.data
old_vector	dw	?
		dw	?
speed		dw	?
parity		db	?
data_bits	db	?

RBR	=	0
THR	=	0
DLATCH	=	0
IER	=	1
IIR	=	2
LCR	=	3
MCR	=	4
LSR	=	5
MSR	=	6

	.code
	extern	_rs232_base_addr:word, _interrupt_number:byte
	extern	_buffer:byte, _buffer_put_ptr:word

data_segment	dw	?

set_comm_params_:		; speed,data_bits,parity,stop_bits
	mov	speed,ax
	mov	data_bits,dl
	mov	parity,bl
	mov	bx,_rs232_base_addr
	lea	dx,[bx+LCR]
	mov	al,80h
	out	dx,al		; DLAB=1
	mov	dx,1		; poids fort 115200
	mov	ax,49664	; poids fbl 115200
	div	speed		; 115200 div speed
	lea	dx,[bx+DLATCH]
	out	dx,al
	mov	al,ah
	inc	dx
	out	dx,al
	mov	al,data_bits
	sub	al,5
	mov	ah,al
	mov	al,parity
	cmp	al,'N'
	je	stopbits
	or	ah,8
	cmp	al,'E'
	jne	stopbits
	or	ah,16
stopbits:
	mov	al,cl	; stop bits
	cmp	al,1
	je	setlcr
	or	ah,4
setlcr:
	mov	al,ah
	lea	dx,[bx+LCR]
	out	dx,al
	ret
	
install_rs232_:
	push	ax
	push	dx
	push	bx
	push	cx
	mov	data_segment,ds
	mov	bx,_rs232_base_addr
	lea	dx,[bx+IER]
	mov	al,0Fh
	out	dx,al	; enable all interrupts
clear:	lea	dx,[bx+IIR]
	in	al,dx
	test	al,1	; rien ?
	jnz	ok
	cmp	al,0	; modem status ?
	jne	l1
	lea	dx,[bx+MSR]
	in	al,dx
	jmp	clear
l1:	cmp	al,2	; THR empty ?
	je	clear
	cmp	al,4	; Received data ready ?
	jne	l2
	lea	dx,[bx+RBR]
	in	al,dx
	jmp	clear
l2:	cmp	al,6	; line status ?
	jne	clear
	lea	dx,[bx+LSR]
	in 	al,dx
	jmp	clear
ok:
	lea	dx,[bx+MCR]
	mov	al,0Bh	; DTR+RTS+OUT2
	out	dx,al
	mov	al,1	; RCV interrupt seulement
	lea	dx,[bx+IER]
	out	dx,al
	
	push	ds
	push	es
	mov	al,_interrupt_number
	add	al,8
	mov	ah,35h
	int	21h	; get old interrupt vector
	mov	old_vector,bx
	mov	old_vector+2,es
	mov	ax,cs
	mov	ds,ax
	mov	al,_interrupt_number
	add	al,8
	mov	dx,OFFSET rs232_handler
	mov	ah,25h
	int	21h	; set new interrupt vector
	pop	es
	pop	ds
	
	mov	cl,_interrupt_number
	mov	ax,1
	stc
	rcl	ax,cl
	not	ax
	cmp	cl,8
	jae	slave_pic
	mov	ah,al
	in	al,21h
	and	al,ah
	out	21h,al
	mov	al,20h	; EOI
	out	20h,al
	jmp	end_inst
slave_pic:
	in	al,71h
	and	al,ah
	out	71h,al
	mov	al,20h	; EOI
	out	70h,al
end_inst:
	pop	cx
	pop	bx
	pop	dx
	pop	ax
	ret
	
uninstall_rs232_:
	push	ax
	push	dx
	push	bx
	push	cx
	mov	cl,_interrupt_number
	mov	ax,1
	stc
	rcl	ax,cl
	cmp	cl,8
	jae	disable_on_slave_pic
	mov	ah,al
	in	al,21h
	or	al,ah
	out	21h,al
	jmp	disable_uart_ints
disable_on_slave_pic:
	in	al,71h
	or	al,ah
	out	71h,al
disable_uart_ints:
	mov	al,0
	mov	bx,_rs232_base_addr
	lea	dx,[bx+IER]
	out	dx,al
	
	push	ds
	mov	al,_interrupt_number
	add	al,8
	mov	dx,old_vector
	mov	ds,old_vector+2
	mov	ah,25h
	int	21h
	pop	ds
	pop	cx
	pop	bx
	pop	dx
	pop	ax
	ret
	
rs232_handler:
	push	ds
	push	ax
	push	dx
	push	bx
	mov	al,20h
	out	20h,al
	mov	ds,data_segment
	mov	dx,_rs232_base_addr
	in	al,dx
	mov	bx,_buffer_put_ptr
	mov	_buffer[bx],al
	inc	bx
	and	bx,1FFFh
	mov	_buffer_put_ptr,bx
	pop	bx
	pop	dx
	pop	ax
	pop	ds
	iret

put_rs232_:
	push	ax
	push	bx
	push	dx
	mov	ah,al
	mov	bx,_rs232_base_addr
	lea	dx,[bx+LSR]
wait_empty:
	in	al,dx
	and	al,020h
	jz	wait_empty
	lea	dx,[bx+THR]
	mov	al,ah
	out	dx,al
	pop	dx
	pop	bx
	pop	ax
	ret
	
	end
